# A basic linked list implementation.
# Note: Since this file contains two classes, the file
# is named after LinkedList, the more important class.
# 
# Author: David Kauchak
# Date: 2/15/2012

# A node in the linked list
#
class Node
	attr_accessor :next
	attr_reader :value
	
	# create a node with value stored in it
	def initialize(value)
		@value = value
	end
end

# A basic linked list
#
class LinkedList
	# Add the value to the front of the linked list
	def add(value)
		if @head == nil
			@head = Node.new(value)
		else
			temp = @head
			@head = Node.new(value)
			@head.next = temp
		end
	end
	
	# Remove the value at the front of the linked list
	# and return it
	def remove
		if @head != nil
			temp = @head
			@head = @head.next
			return temp.value
		end
	end
		
	# write out the contents of the linked list
	def to_s
		temp = @head
		
		s = ""
		
		while temp != nil
			s += temp.value.to_s + " "
			temp = temp.next
		end
		
		return s
	end
end